# Class SublayerExtensionCollectionBase`Abstract`

Backing implementation of mapping/support/_SublayerExtensionCollection!SublayerExtensionCollection. Used by LayerExtension and SublayerExtension.

#### Hierarchy (view full)

- InitializableCollectionProxy<SublayerExtensionProperties, SublayerExtension>
  - SublayerExtensionCollectionBase
    - SubSublayerExtensionCollection

#### Implements

- SublayerExtensionCollection

#####
Index

### Constructors

constructor

### Properties

_parent

### Accessors

_collection
_layerExtension
declaredClass
destroyed
initialized
initializedItems
length

### Methods

_get
_itemIsInitialized
_onAdded
_onRemoved
_set
[iterator]
add
addHandles
addMany
at
clone
concat
destroy
every
filter
find
findById
findBySublayerId
findIndex
flatten
forEach
forSublayer
get
getItemAt
hasHandles
includes
indexOf
join
lastIndexOf
map
notifyChange
on
onLayerExtensionChanged
onParentInitialized
pop
push
reduce
reduceRight
remove
removeAll
removeAt
removeHandles
removeMany
reorder
reverse
set
shift
slice
some
sort
splice
toArray
unshift
watch

##
Constructors

### constructor

- new SublayerExtensionCollectionBase(parent, sublayersProperty): SublayerExtensionCollectionBase

- Creates a new instance of SublayerExtensionCollectionBase.

  #### Parameters

  - parent: Observable

    The parent object that owns the collection of sublayers.

  - sublayersProperty: string

    The name of a property (or property path) on the parent corresponding to the underlying collection of sublayers.

  #### Returns SublayerExtensionCollectionBase

  Overrides InitializableCollectionProxy.constructor

##
Properties

### `Protected` `Readonly`_parent

_parent: Observable

The parent that owns this collection.

##
Accessors

### `Protected`_collection

- get _collection(): Collection<SublayerExtension<SublayerExtensionProperties>>

- The underlying collection that this class delegates to.

  #### Returns Collection<SublayerExtension<SublayerExtensionProperties>>

  Overrides InitializableCollectionProxy._collection

### `Protected` `Abstract`_layerExtension

- get _layerExtension(): LayerExtension<LayerExtensionProperties>

- The layer extension that the collection of sublayers is associated with.

  #### Returns LayerExtension<LayerExtensionProperties>

### declaredClass

- get declaredClass(): string

- The declared class name. This is always `"esri.core.Collection"` for compatibility with Esri's API.

  #### Returns string

  Implementation of SublayerExtensionCollection.declaredClass

  Inherited from InitializableCollectionProxy.declaredClass

### destroyed

- get destroyed(): boolean

- Whether the collection has been destroyed.

  #### Returns boolean

  Implementation of SublayerExtensionCollection.destroyed

  Inherited from InitializableCollectionProxy.destroyed

- set destroyed(value): void

- #### Parameters

  - value: boolean

  #### Returns void

  Implementation of SublayerExtensionCollection.destroyed

  Inherited from InitializableCollectionProxy.destroyed

### initialized

- get initialized(): boolean

- Whether the collection has been initialized.

  #### Returns boolean

  Implementation of SublayerExtensionCollection.initialized

  Inherited from InitializableCollectionProxy.initialized

- set initialized(value): void

- #### Parameters

  - value: boolean

  #### Returns void

  Implementation of SublayerExtensionCollection.initialized

  Inherited from InitializableCollectionProxy.initialized

### initializedItems

- get initializedItems(): ReadOnlyCollection<T>

- Returns a collection of the initialized items.

  #### Returns ReadOnlyCollection<T>

  Implementation of SublayerExtensionCollection.initializedItems

  Inherited from InitializableCollectionProxy.initializedItems

### length

- get length(): number

- The number of items in the collection.

  #### Returns number

  Implementation of SublayerExtensionCollection.length

  Inherited from InitializableCollectionProxy.length

##
Methods

### `Protected`_get

- _get(propertyName): any

- #### Parameters

  - propertyName: string

  #### Returns any

  #### Deprecated

  - Unsupported on CollectionProxy.

  #### Inherit Doc

  Implementation of SublayerExtensionCollection._get

  Inherited from InitializableCollectionProxy._get

- _get<T>(propertyName): T

- #### Type Parameters

  - T

  #### Parameters

  - propertyName: string

  #### Returns T

  Implementation of SublayerExtensionCollection._get

  Inherited from InitializableCollectionProxy._get

### `Protected`_itemIsInitialized

- _itemIsInitialized(item): boolean

- Returns whether an item in the collection is considered initialized.

  #### Parameters

  - item: SublayerExtension<SublayerExtensionProperties>

    The item being checked for initialization.

  #### Returns boolean

  Overrides InitializableCollectionProxy._itemIsInitialized

### `Protected`_onAdded

- _onAdded(sublayerExtension): void

- Invoked whenever a sublayer extension is added.

  #### Parameters

  - sublayerExtension: SublayerExtension<SublayerExtensionProperties>

    The new sublayer extension.

  #### Returns void

### `Protected`_onRemoved

- _onRemoved(sublayerExtension): void

- Invoked whenever a sublayer extension is removed.

  #### Parameters

  - sublayerExtension: SublayerExtension<SublayerExtensionProperties>

    The sublayer extension that was removed.

  #### Returns void

### `Protected`_set

- _set<T>(propertyName, value): this

- #### Type Parameters

  - T

  #### Parameters

  - propertyName: string
  - value: T

  #### Returns this

  #### Deprecated

  - Unsupported on CollectionProxy.

  #### Inherit Doc

  Implementation of SublayerExtensionCollection._set

  Inherited from InitializableCollectionProxy._set

### [iterator]

- [iterator](): IterableIterator<SublayerExtension<SublayerExtensionProperties>, any, any>

- #### Returns IterableIterator<SublayerExtension<SublayerExtensionProperties>, any, any>

  #### Inherit Doc

  Implementation of SublayerExtensionCollection.[iterator]

  Inherited from InitializableCollectionProxy.[iterator]

### add

- add(sublayerX, index?): this

- Adds a single item to the collection.

  #### Parameters

  - sublayerX: SublayerExtension<SublayerExtensionProperties>
  - `Optional` index: number

    Zero-based index of where in the collection to add the item. If not specified, the items will be added at the end.

  #### Returns this

  Implementation of SublayerExtensionCollection.add

  Overrides InitializableCollectionProxy.add

### addHandles

- addHandles<T>(handles, groupKey?): void

- #### Type Parameters

  - T

  #### Parameters

  - handles: IHandle | IHandle[]
  - `Optional` groupKey: Exclude<T, IHandle>

  #### Returns void

  Implementation of SublayerExtensionCollection.addHandles

  Inherited from InitializableCollectionProxy.addHandles

### addMany

- addMany(items, index?): this

- Adds multiple items to the collection.

  #### Parameters

  - items: Collection<SublayerExtension<SublayerExtensionProperties>> | ArrayLike<SublayerExtension<SublayerExtensionProperties>>

    An array or collection of items to add.

  - `Optional` index: number

    Zero-based index of where in the collection to add the items. If not specified, the items will be added at the end.

  #### Returns this

  Implementation of SublayerExtensionCollection.addMany

  Inherited from InitializableCollectionProxy.addMany

### at

- at(index): SublayerExtension<SublayerExtensionProperties>

- Returns the item at the specified index.

  #### Parameters

  - index: number

    Zero-based index of the item in the Collection to retrieve.

  #### Returns SublayerExtension<SublayerExtensionProperties>

  The item in the Collection stored at the specified index.

  Implementation of SublayerExtensionCollection.at

  Inherited from InitializableCollectionProxy.at

### clone

- clone(): SublayerExtensionCollectionBase

- Creates a deep clone of the Collection. To create a shallow clone of the collection, use slice().

  #### Returns SublayerExtensionCollectionBase

  Implementation of SublayerExtensionCollection.clone

  Overrides InitializableCollectionProxy.clone

### concat

- concat(value): Collection<SublayerExtension<SublayerExtensionProperties>>

- Creates a new Collection containing the items in the original Collection joined with the items in the input array or Collection.

  #### Parameters

  - value: Collection<SublayerExtension<SublayerExtensionProperties>> | SublayerExtension<SublayerExtensionProperties>[]

    The array or Collection to append to the existing Collection.

  #### Returns Collection<SublayerExtension<SublayerExtensionProperties>>

  Implementation of SublayerExtensionCollection.concat

  Inherited from InitializableCollectionProxy.concat

### destroy

- destroy(): void

- Removes all event listeners and destroys the collection.

  #### Returns void

  Implementation of SublayerExtensionCollection.destroy

  Inherited from InitializableCollectionProxy.destroy

### every

- every(callback): boolean

- Determines whether all items in the Collection pass a test defined by callback. Each item in the Collection is passed into the callback until one returns a value of false.

  #### Parameters

  - callback: ItemTestCallback<SublayerExtension<SublayerExtensionProperties>>

    The function to call for each item in the Collection.

  #### Returns boolean

  Implementation of SublayerExtensionCollection.every

  Inherited from InitializableCollectionProxy.every

### filter

- filter(callback): Collection<SublayerExtension<SublayerExtensionProperties>>

- Filters the Collection's items based on a test defined by the callback function. Each item is passed into the callback function, which returns true if the item passes the test and false if it does not.

  #### Parameters

  - callback: ItemTestCallback<SublayerExtension<SublayerExtensionProperties>>

    The function that defines a test for determining whether to return the item in a new Collection.

  #### Returns Collection<SublayerExtension<SublayerExtensionProperties>>

  Implementation of SublayerExtensionCollection.filter

  Inherited from InitializableCollectionProxy.filter

### find

- find(callback): SublayerExtension<SublayerExtensionProperties>

- Returns an item in the Collection if that item passes a test as defined in the callback function. Each item is passed into the callback function, which returns true if the item passes the test and false if it does not.

  #### Parameters

  - callback: ItemTestCallback<SublayerExtension<SublayerExtensionProperties>>

    The testing function that will assess each item in the Collection. Returns true if an item passes the test and false if it fails.

  #### Returns SublayerExtension<SublayerExtensionProperties>

  Implementation of SublayerExtensionCollection.find

  Inherited from InitializableCollectionProxy.find

### findById

- findById(id): SublayerExtension<SublayerExtensionProperties>

- Get the sublayer extension for a given id.

  #### Parameters

  - id: string

    The id of the sublayer extension.

  #### Returns SublayerExtension<SublayerExtensionProperties>

  The sublayer extension.

  Implementation of SublayerExtensionCollection.findById

### findBySublayerId

- findBySublayerId(id): SublayerExtension<SublayerExtensionProperties>

- Get the corresponding sublayer extension for a given sublayer id.

  #### Parameters

  - id: string | number

    The id of the sublayer.

  #### Returns SublayerExtension<SublayerExtensionProperties>

  The corresponding sublayer extension.

  Implementation of SublayerExtensionCollection.findBySublayerId

### findIndex

- findIndex(callback): number

- Returns the index of an item in the Collection if that item passes a test as defined in the callback function. Each item is passed into the callback function, which returns true if the item passes the test and false if it does not.

  #### Parameters

  - callback: ItemTestCallback<SublayerExtension<SublayerExtensionProperties>>

    The testing function that will assess each item in the Collection. Returns true if an item passes the test and false if it fails.

  #### Returns number

  Returns the index of the Collection item that satisfies the test function. If an item fails the test, -1 is returned.

  Implementation of SublayerExtensionCollection.findIndex

  Inherited from InitializableCollectionProxy.findIndex

### flatten

- flatten(callback): Collection<SublayerExtension<SublayerExtensionProperties>>

- Flattens a hierarchical Collection containing at least one child collection. Each item in the collection is passed into the callback function, which should check for child collections specified by the developer. A flat collection of all items (parent and children) is returned.

  #### Parameters

  - callback: ((item: SublayerExtension<SublayerExtensionProperties>, index: number) => Collection<SublayerExtension<SublayerExtensionProperties>> | SublayerExtension<SublayerExtensionProperties>[])

    A function that will assess each item in the Collection.

    - - (item, index): Collection<SublayerExtension<SublayerExtensionProperties>> | SublayerExtension<SublayerExtensionProperties>[]

      - #### Parameters

        - item: SublayerExtension<SublayerExtensionProperties>
        - index: number

        #### Returns Collection<SublayerExtension<SublayerExtensionProperties>> | SublayerExtension<SublayerExtensionProperties>[]

  #### Returns Collection<SublayerExtension<SublayerExtensionProperties>>

  Implementation of SublayerExtensionCollection.flatten

  Inherited from InitializableCollectionProxy.flatten

### forEach

- forEach(callback): void

- Executes the input function for each item in the Collection.

  #### Parameters

  - callback: ItemCallback<SublayerExtension<SublayerExtensionProperties>>

    The function to call for each item in the Collection.

  #### Returns void

  Implementation of SublayerExtensionCollection.forEach

  Inherited from InitializableCollectionProxy.forEach

### forSublayer

- forSublayer(sublayer): SublayerExtension<SublayerExtensionProperties>

- Gets the corresponding sublayer extension for a given sublayer.

  #### Parameters

  - sublayer: SublayerLike

    A sublayer.

  #### Returns SublayerExtension<SublayerExtensionProperties>

  The corresponding sublayer extension.

  Implementation of SublayerExtensionCollection.forSublayer

### get

- get<T>(propertyPath): T

- #### Type Parameters

  - T

  #### Parameters

  - propertyPath: string

  #### Returns T

  #### Deprecated

  - Unsupported on CollectionProxy.

  #### Inherit Doc

  Implementation of SublayerExtensionCollection.get

  Inherited from InitializableCollectionProxy.get

- get(propertyPath): unknown

- #### Parameters

  - propertyPath: string

  #### Returns unknown

  #### Deprecated

  - Unsupported on CollectionProxy.

  #### Inherit Doc

  Implementation of SublayerExtensionCollection.get

  Inherited from InitializableCollectionProxy.get

### getItemAt

- getItemAt(index): SublayerExtension<SublayerExtensionProperties>

- Returns the item at the specified index.

  #### Parameters

  - index: number

    Zero-based index of the item in the Collection to retrieve.

  #### Returns SublayerExtension<SublayerExtensionProperties>

  The item in the Collection stored at the specified index.

  Implementation of SublayerExtensionCollection.getItemAt

  Inherited from InitializableCollectionProxy.getItemAt

### hasHandles

- hasHandles<T>(groupKey?): boolean

- #### Type Parameters

  - T

  #### Parameters

  - `Optional` groupKey: Exclude<T, IHandle>

  #### Returns boolean

  Implementation of SublayerExtensionCollection.hasHandles

  Inherited from InitializableCollectionProxy.hasHandles

### includes

- includes(searchElement): boolean

- Tests if an item is present in the Collection.

  #### Parameters

  - searchElement: SublayerExtension<SublayerExtensionProperties>

    The item to search for in the collection.

  #### Returns boolean

  Implementation of SublayerExtensionCollection.includes

  Inherited from InitializableCollectionProxy.includes

### indexOf

- indexOf(searchElement, fromIndex?): number

- Returns the index of an element in the collection.

  #### Parameters

  - searchElement: SublayerExtension<SublayerExtensionProperties>

    Item to search for in the collection.

  - `Optional` fromIndex: number

    Use if you don't want to search the whole collection or you don't want to search from the start.

  #### Returns number

  Implementation of SublayerExtensionCollection.indexOf

  Inherited from InitializableCollectionProxy.indexOf

### join

- join(separator?): string

- Creates a string representation of the items in the Collection.

  #### Parameters

  - `Optional` separator: string

    The separator used between each item in the final string. The default is ",".

  #### Returns string

  Implementation of SublayerExtensionCollection.join

  Inherited from InitializableCollectionProxy.join

### lastIndexOf

- lastIndexOf(searchElement, fromIndex?): number

- Returns the last index of an element in the collection.

  #### Parameters

  - searchElement: SublayerExtension<SublayerExtensionProperties>

    Item to search for in the collection.

  - `Optional` fromIndex: number

    Use if you don't want to search the whole collection, or you don't want to search from the end.

  #### Returns number

  The location of the last match found in the collection, or -1 if there is no match.

  Implementation of SublayerExtensionCollection.lastIndexOf

  Inherited from InitializableCollectionProxy.lastIndexOf

### map

- map<U>(callback): Collection<U>

- Passes each Collection item into the callback function and returns a new array of the returned values.

  #### Type Parameters

  - U

  #### Parameters

  - callback: ItemMapCallback<SublayerExtension<SublayerExtensionProperties>, U>

    The function that processes each item in the Collection and returns a new value at the same index of the original item.

  #### Returns Collection<U>

  Implementation of SublayerExtensionCollection.map

  Inherited from InitializableCollectionProxy.map

### `Protected` notifyChange

- notifyChange(propertyKey): void

- #### Parameters

  - propertyKey: string

  #### Returns void

  #### Deprecated

  - Unsupported on CollectionProxy.

  #### Inherit Doc

  Implementation of SublayerExtensionCollection.notifyChange

  Inherited from InitializableCollectionProxy.notifyChange

- notifyChange(propertyKey): void

- #### Parameters

  - propertyKey: keyof SublayerExtensionCollectionBase

  #### Returns void

  Implementation of SublayerExtensionCollection.notifyChange

  Inherited from InitializableCollectionProxy.notifyChange

### on

- on(type, listener): IHandle

- #### Parameters

  - type: "after-add"
  - listener: CollectionAfterAddEventHandler<LayerExtension<LayerExtensionProperties>>

  #### Returns IHandle

  #### Inherit Doc

  Implementation of SublayerExtensionCollection.on

  Overrides InitializableCollectionProxy.on

- on(type, listener): IHandle

- #### Parameters

  - type: "after-changes"
  - listener: CollectionAfterChangesEventHandler

  #### Returns IHandle

  Implementation of SublayerExtensionCollection.on

  Overrides InitializableCollectionProxy.on

- on(type, listener): IHandle

- #### Parameters

  - type: "after-remove"
  - listener: CollectionAfterRemoveEventHandler<LayerExtension<LayerExtensionProperties>>

  #### Returns IHandle

  Implementation of SublayerExtensionCollection.on

  Overrides InitializableCollectionProxy.on

- on(type, listener): IHandle

- #### Parameters

  - type: "before-add"
  - listener: CollectionBeforeAddEventHandler<LayerExtension<LayerExtensionProperties>>

  #### Returns IHandle

  Implementation of SublayerExtensionCollection.on

  Overrides InitializableCollectionProxy.on

- on(type, listener): IHandle

- #### Parameters

  - type: "before-changes"
  - listener: CollectionBeforeChangesEventHandler

  #### Returns IHandle

  Implementation of SublayerExtensionCollection.on

  Overrides InitializableCollectionProxy.on

- on(type, listener): IHandle

- #### Parameters

  - type: "before-remove"
  - listener: CollectionBeforeRemoveEventHandler<LayerExtension<LayerExtensionProperties>>

  #### Returns IHandle

  Implementation of SublayerExtensionCollection.on

  Overrides InitializableCollectionProxy.on

- on(type, listener): IHandle

- #### Parameters

  - type: "change"
  - listener: CollectionChangeEventHandler<LayerExtension<LayerExtensionProperties>>

  #### Returns IHandle

  Implementation of SublayerExtensionCollection.on

  Overrides InitializableCollectionProxy.on

- on(type, listener): IHandle

- #### Parameters

  - type: string
  - listener: EventHandler

  #### Returns IHandle

  Implementation of SublayerExtensionCollection.on

  Overrides InitializableCollectionProxy.on

### onLayerExtensionChanged

- onLayerExtensionChanged(): void

- Invoked by the parent whenever the associated layer extension is updated.

  #### Returns void

### onParentInitialized

- onParentInitialized(): void

- Invoked by the parent object when it is initialized.

  #### Returns void

### pop

- pop(): SublayerExtension<SublayerExtensionProperties>

- Removes the last item from the collection and returns it.

  #### Returns SublayerExtension<SublayerExtensionProperties>

  Implementation of SublayerExtensionCollection.pop

  Inherited from InitializableCollectionProxy.pop

### push

- push(item): number

- Adds an item to the end of the collection.

  #### Parameters

  - item: SublayerExtension<SublayerExtensionProperties>

    The item to add.

  #### Returns number

  Implementation of SublayerExtensionCollection.push

  Inherited from InitializableCollectionProxy.push

### reduce

- reduce<U>(callback, initialValue?): U

- Reduces all items in the collection (from left to right) into a single variable using callback.

  #### Type Parameters

  - U

  #### Parameters

  - callback: ItemReduceCallback<SublayerExtension<SublayerExtensionProperties>, U>

    The function that processes each item in the Collection and appends it to the previous item.

  - `Optional` initialValue: U

    Item to use as the first element to process in callback.

  #### Returns U

  Implementation of SublayerExtensionCollection.reduce

  Inherited from InitializableCollectionProxy.reduce

### reduceRight

- reduceRight<U>(callback, initialValue?): U

- Reduces all items in the collection (from right to left) into a single variable using callback.

  #### Type Parameters

  - U

  #### Parameters

  - callback: ItemReduceCallback<SublayerExtension<SublayerExtensionProperties>, U>

    The function that processes each item in the Collection and appends it to the previous item.

  - `Optional` initialValue: U

    Item to use as the first element to process in callback.

  #### Returns U

  Implementation of SublayerExtensionCollection.reduceRight

  Inherited from InitializableCollectionProxy.reduceRight

### remove

- remove(item): SublayerExtension<SublayerExtensionProperties>

- Removes an item from the collection.

  #### Parameters

  - item: SublayerExtension<SublayerExtensionProperties>

    The item to remove.

  #### Returns SublayerExtension<SublayerExtensionProperties>

  Implementation of SublayerExtensionCollection.remove

  Inherited from InitializableCollectionProxy.remove

### removeAll

- removeAll(): SublayerExtension<SublayerExtensionProperties>[]

- Removes all items from the collection.

  #### Returns SublayerExtension<SublayerExtensionProperties>[]

  Implementation of SublayerExtensionCollection.removeAll

  Inherited from InitializableCollectionProxy.removeAll

### removeAt

- removeAt(index): SublayerExtension<SublayerExtensionProperties>

- Removes an item from the collection at a specified index.

  #### Parameters

  - index: number

    The index of the element to remove.

  #### Returns SublayerExtension<SublayerExtensionProperties>

  Implementation of SublayerExtensionCollection.removeAt

  Overrides InitializableCollectionProxy.removeAt

### removeHandles

- removeHandles<T>(groupKey?): void

- #### Type Parameters

  - T

  #### Parameters

  - `Optional` groupKey: Exclude<T, IHandle>

  #### Returns void

  Implementation of SublayerExtensionCollection.removeHandles

  Inherited from InitializableCollectionProxy.removeHandles

### removeMany

- removeMany(items): SublayerExtension<SublayerExtensionProperties>[]

- Removes each item in the input array. If an item is present multiple times in the collection, only the first occurrence is removed.

  #### Parameters

  - items: Collection<SublayerExtension<SublayerExtensionProperties>> | ArrayLike<SublayerExtension<SublayerExtensionProperties>>

    The items to remove.

  #### Returns SublayerExtension<SublayerExtensionProperties>[]

  Implementation of SublayerExtensionCollection.removeMany

  Inherited from InitializableCollectionProxy.removeMany

### reorder

- reorder(sublayerX, index): SublayerExtension<SublayerExtensionProperties>

- Moves an item in the Collection to a specified index. The change event is fired after an item is moved in the Collection.

  #### Parameters

  - sublayerX: SublayerExtension<SublayerExtensionProperties>
  - index: number

    The index to move the item to.

  #### Returns SublayerExtension<SublayerExtensionProperties>

  Implementation of SublayerExtensionCollection.reorder

  Overrides InitializableCollectionProxy.reorder

### reverse

- reverse(): this

- Reverses the collection in place.

  #### Returns this

  Implementation of SublayerExtensionCollection.reverse

  Inherited from InitializableCollectionProxy.reverse

### set

- set<T>(propertyPath, value): this

- #### Type Parameters

  - T

  #### Parameters

  - propertyPath: string
  - value: T

  #### Returns this

  #### Deprecated

  - Unsupported on CollectionProxy.

  #### Inherit Doc

  Implementation of SublayerExtensionCollection.set

  Inherited from InitializableCollectionProxy.set

- set(properties): this

- #### Parameters

  - properties: HashMap<unknown>

  #### Returns this

  #### Deprecated

  - Unsupported on CollectionProxy.

  #### Inherit Doc

  Implementation of SublayerExtensionCollection.set

  Inherited from InitializableCollectionProxy.set

### shift

- shift(): SublayerExtension<SublayerExtensionProperties>

- Removes the first item from the collection (at index 0), and returns it. The remaining items of the collection are then shifted down one index from their previous location.

  #### Returns SublayerExtension<SublayerExtensionProperties>

  Implementation of SublayerExtensionCollection.shift

  Inherited from InitializableCollectionProxy.shift

### slice

- slice(begin?, end?): Collection<SublayerExtension<SublayerExtensionProperties>>

- Creates a new Collection comprised of a portion of the original Collection.

  #### Parameters

  - `Optional` begin: number

    The index of the first item to extract.

  - `Optional` end: number

    The index of the last item to extract.

  #### Returns Collection<SublayerExtension<SublayerExtensionProperties>>

  Implementation of SublayerExtensionCollection.slice

  Inherited from InitializableCollectionProxy.slice

### some

- some(callback): boolean

- Determines whether an item in the Collection passes a test defined by callback. Each item in the Collection is passed into the callback until one returns a value of true.

  #### Parameters

  - callback: ItemTestCallback<SublayerExtension<SublayerExtensionProperties>>

    The function that defines the test for each Collection item.

  #### Returns boolean

  Implementation of SublayerExtensionCollection.some

  Inherited from InitializableCollectionProxy.some

### sort

- sort(compareFunction?): this

- Sorts the Collection in place.

  #### Parameters

  - `Optional` compareFunction: ((a: SublayerExtension<SublayerExtensionProperties>, b: SublayerExtension<SublayerExtensionProperties>) => number)

    The function that defines a comparison of two items in the collection.

    - - (a, b): number

      - #### Parameters

        - a: SublayerExtension<SublayerExtensionProperties>
        - b: SublayerExtension<SublayerExtensionProperties>

        #### Returns number

  #### Returns this

  Implementation of SublayerExtensionCollection.sort

  Overrides InitializableCollectionProxy.sort

### splice

- splice(start, deleteCount, ...items): SublayerExtension<SublayerExtensionProperties>[]

- Removes existing items and/or adds new items to the collection.

  #### Parameters

  - start: number

    Index at which to start changing the collection.

  - deleteCount: number

    Indicates the number of collection items to remove. If 0 is used then no elements are removed and at least one new item should be added in the items parameter.

  - `Rest`...items: SublayerExtension<SublayerExtensionProperties>[]

    The item or comma-separated list of items to add to the collection.

  #### Returns SublayerExtension<SublayerExtensionProperties>[]

  An array of the deleted items formerly part of the collection.

  Implementation of SublayerExtensionCollection.splice

  Inherited from InitializableCollectionProxy.splice

### toArray

- toArray(): SublayerExtension<SublayerExtensionProperties>[]

- Returns a new array object containing the Collection's items.

  #### Returns SublayerExtension<SublayerExtensionProperties>[]

  Implementation of SublayerExtensionCollection.toArray

  Inherited from InitializableCollectionProxy.toArray

### unshift

- unshift(item): number

- Adds an item to the beginning of the collection.

  #### Parameters

  - item: SublayerExtension<SublayerExtensionProperties>

    The item to add.

  #### Returns number

  Implementation of SublayerExtensionCollection.unshift

  Inherited from InitializableCollectionProxy.unshift

### watch

- watch(path, callback, sync?): IHandle

- #### Parameters

  - path: string | string[]
  - callback: ((newValue: any, oldValue: any, propertyName: string, target: any) => void)
    - - (newValue, oldValue, propertyName, target): void

      - #### Parameters

        - newValue: any
        - oldValue: any
        - propertyName: string
        - target: any

        #### Returns void

  - `Optional` sync: boolean

  #### Returns IHandle

  #### Deprecated

  - Unsupported on CollectionProxy.

  #### Inherit Doc

  Implementation of SublayerExtensionCollection.watch

  Inherited from InitializableCollectionProxy.watch